package cn.dejavu.AdvancedChatFilter;

import net.md_5.bungee.api.ChatMessageType;
import net.md_5.bungee.api.chat.TextComponent;
import net.md_5.bungee.api.config.ServerInfo;
import net.md_5.bungee.api.connection.Connection;
import net.md_5.bungee.api.connection.ProxiedPlayer;
import net.md_5.bungee.api.event.ChatEvent;
import net.md_5.bungee.api.plugin.Listener;
import net.md_5.bungee.api.plugin.Plugin;
import net.md_5.bungee.config.Configuration;
import net.md_5.bungee.config.ConfigurationProvider;
import net.md_5.bungee.config.YamlConfiguration;
import net.md_5.bungee.event.EventHandler;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.nio.file.Files;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.logging.Level;

public class Main extends Plugin implements Listener {
    Configuration configuration;
    static Main instance;
    private List<String> censorWords = new ArrayList<>();
    @Override
    public void onEnable() {
        instance = this;
        getLogger().info("AdvancedChatFilter by Deja_Vu deleveop Team");
        getLogger().info("Loading config...");
        loadConfig();
        getProxy().getPluginManager().registerListener(this,this);
        censorWords=configuration.getStringList("words");

    }
    @EventHandler
    public void onChat(ChatEvent e){
        String msg = e.getMessage();
        ProxiedPlayer sender = (ProxiedPlayer) e.getSender();
        Connection receiver = e.getReceiver();
        //First check is or not contain censorWords.
        for (String singleCensorWord : censorWords){
           boolean contain = msg.contains(singleCensorWord);
           if(contain){
               if(msg.startsWith("/"))
                   return; //Ignore command
               //Check is it contain censor username player in same server with detect player
               String bungeeServer = sender.getServer().getInfo().getName();
               ServerInfo inServer = getProxy().getServerInfo(bungeeServer);
               Collection<ProxiedPlayer> playerInSameServer = inServer.getPlayers();

               for (ProxiedPlayer inSameServerPlayer : playerInSameServer) {
                   if (inSameServerPlayer.getName().contains(singleCensorWord))
                        return; //Maybe just call that player
               }

               //All not, 盘他
                processCensorWord(sender,receiver,singleCensorWord);
                e.setCancelled(true);
                return;
           }
        }


    }

    private void processCensorWord(ProxiedPlayer sender, Connection receiver, String singleCensorWord){
        sender.sendMessage(ChatMessageType.CHAT, new TextComponent(configuration.getString("msg.censor-word-detected")));
        new censorWebhook(sender,receiver,singleCensorWord);
    }

    private void loadConfig(){
        if (!getDataFolder().exists())
            getDataFolder().mkdir();
        File file = new File(getDataFolder(), "config.yml");

        if (!file.exists()) {
            try (InputStream in = getResourceAsStream("config.yml")) {
                Files.copy(in, file.toPath()); //Create default config file.
            } catch (IOException e) {
                e.printStackTrace();
            }
        }

        try {
            configuration = ConfigurationProvider.getProvider(YamlConfiguration.class).load(new File(getDataFolder(), "config.yml"));
        }catch (IOException e){
            getLogger().log(Level.SEVERE,"Failed to load configuration.");
            e.printStackTrace();
        }
    }

    private void saveConfig(){
        try {
        ConfigurationProvider.getProvider(YamlConfiguration.class).save(configuration, new File(getDataFolder(), "config.yml"));
        }catch (IOException e){
            getLogger().log(Level.SEVERE,"Failed to save configuration.");
            e.printStackTrace();
        }
    }
}
